{ TThread }

//  EThread = class(Exception);


  TThreadMethod = procedure of object;
  TThreadPriority = (tpIdle, tpLowest, tpLower, tpNormal, tpHigher, tpHighest,
    tpTimeCritical);


  TThread = class
  private
{$ifdef linux}
    { Needed for linux }
    FStackPointer : integer;
    FStackSize    : integer;
{$endif}
    FHandle: THandle;       // PID
    FHandle2: THandle;      // 0, 1,  ...
    FThreadID: Integer;     // 0 .. MaxThreadCount - 1
    FTerminated: Boolean;
    FSuspended: Boolean;
    FFreeOnTerminate: Boolean;
    FFinished: Boolean;     // Thread will is not running any more 
    FError: Integer;
    FReturnValue: Integer;
    FOnTerminate: TNotifyEvent;
    FMethod: TThreadMethod;
    FSynchronizeException: TObject;
    FPriority: TThreadPriority;
    procedure CallOnTerminate;
    procedure SetPriority(Value: TThreadPriority);
    procedure SetSuspended(Value: Boolean);
  protected
    procedure DoTerminate; virtual;
    procedure Execute; virtual; abstract;
    procedure Synchronize(Method: TThreadMethod);
    property ReturnValue: Integer read FReturnValue write FReturnValue;
    property Terminated: Boolean read FTerminated;
  public
    constructor Create(CreateSuspended: Boolean);
    destructor Destroy;  override; 
    procedure Resume;
    procedure Suspend;
    procedure Terminate;
    function WaitFor: Integer;
    property Handle2: THandle read FHandle2;
    property Handle:  THandle read FHandle;
    property ThreadID: Integer read FThreadID;
    property FreeOnTerminate: Boolean read FFreeOnTerminate write FFreeOnTerminate;
    property Priority: TThreadPriority read FPriority write SetPriority;
    property Suspended: Boolean read FSuspended write SetSuspended;
    property Finished: Boolean read FFinished;
    property Error: Integer read FError;
    property OnTerminate: TNotifyEvent read FOnTerminate write FOnTerminate;
  end;

type
  TFPThreadMessage = record
    MType  : Longint;
    Sender : TThread;
  end;

  PFPThreadRec=^TFPThreadRec;

  TFPThreadRec = record
    thread : TThread;
    next   : PFPThreadRec;
  end;

  TFPThreadsRecord = record
    ThreadsInited : boolean;
    MsgKey: TKey;
    MsgID: Integer;
    SemID: Integer;
    Freed : boolean;
    Root : PFPThreadRec;
  end;

const
    TFPThreadMessageSize = sizeof(TFPThreadMessage)-sizeof(Longint);
    FPMsgSynchonize      = $10;
    FPThreadsMax         = $10;


